//=============================================================================
// Four Nights at OMORI's Plugin
// FNAO.js
//=============================================================================

var Imported = Imported || {};
Imported.STRAWBS_FNAO = true;

var STRAWBS_FNAO = STRAWBS_FNAO || {};
STRAWBS_FNAO.version = 1.0;

//=============================================================================
 /*:
 * @plugindesc v1.0 Custom JavaScript code for Four Nights at
 * OMORI's. Because RPG Maker's events system sucks.
 * @author Michelle B "Faux Female"
 */
//=============================================================================

/*
AudioManager.playSe({name: "ft_2", pan: 0, pitch: 100, volume: 90});
AudioManager.playSe({name: "ft_3", pan: 0, pitch: 100, volume: 90});
AudioManager.playSe({name: "SE_droplet", pan: 0, pitch: 100, volume: 90});
*/

// Set some global variables
var alternator = false;

STRAWBS_FNAO.Game_Interpreter_pluginCommand =
    Game_Interpreter.prototype.pluginCommand;

Game_Interpreter.prototype.pluginCommand = function(command, args) {
  STRAWBS_FNAO.Game_Interpreter_pluginCommand.call(this, command, args);

  if (command === 'PlayRangedFootsteps') {

    // Find events
    var camera = $gameMap.event(19);
    var kel = $gameMap.event(83);

    // Set pan based on whether Kel is left or right of the camera.
    var dynamicPan = 0;

    var cameraX = camera.x;
    var kelX = kel.x;

    dynamicPan = -( ( cameraX - kelX ) * 33);
//    console.log("Pan: " + dynamicPan);

    // Set volume based on how far Kel is from the camera.
    var dynamicVolume = 0;

    var cameraY = camera.y;
    var kelY = kel.y;

    dynamicVolume = 100 - ( ( cameraY - kelY ) * 30);
 //   console.log("Volume: " + dynamicVolume);

    // Alternate sounds
    var soundName = "";

    if ( alternator ) {
        alternator = false;
        soundName = "ft_2";
    } else {
        alternator = true;
        soundName = "ft_3";
    }

    AudioManager.playSe({name: soundName, pan: dynamicPan, pitch: 90, volume: dynamicVolume});

  }

};

// Intercerpt load function to detect normal game saves and block them
/*
  I shamelessly stole this code from nullspace.
  But that's okay because I confessed to the owner of nullspace (Symtrack) afterwards and he said it's fine.
  The good ending.
*/
STRAWBS_FNAO.DataManager_loadGameWithoutRescue = DataManager.loadGameWithoutRescue;
DataManager.loadGameWithoutRescue = function(savefileId) {
    if (STRAWBS_FNAO.DataManager_loadGameWithoutRescue.call(this, savefileId)) {
        console.log($gameVariables.value(23))
        /*if ($gameSwitches.value(7) == 0) {
            // Dream world save, teleport to fight room
            // Code courtesy of FoG
            $gameSwitches.setValue(1994, true);
            return true;
        } else if ($gameVariables.value(23).startsWith("FNAO:")) {*/
            // Is an FNAO save, load normally
            return true;
        /*} else {
            AudioManager.playStaticSe({ "name": "SE_bs_scare1", "pan": 0, "pitch": 100, "volume": 100 });
            return false;
        }*/
    } else {
        return false;
    }
};
